unit Smiley;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls, Graphics;

type
  TSmileyType = (joy, blue);
  TSmiley = class(TImage)
  private
    { Private declarations }
    smileyType:TSmileyType;
    procedure clearCanvas;
  protected
    procedure setType(typ:TSmileyType);
    function getType:TSmileyType;
    { Protected declarations }
  public
     procedure repaint;override;
    { Public declarations }
  published
    { Published declarations }
    property typ:TSmileyType read getType write setType;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TSmiley]);
end;

procedure TSmiley.setType(typ:TSmileyType);
begin
 smileyType := typ;
end;

function TSmiley.getType:TSmileyType;
begin
 getType := smileyType;
end;

procedure TSmiley.repaint;
begin
 clearCanvas;
 if smileyType = joy then
   Canvas.TextOut(5,2,':-)')
 else Canvas.TextOut(5,2,':-(');
end;

procedure TSmiley.clearCanvas;
var color:TColor;
begin
 color := Canvas.Pen.Color;
 Canvas.Pen.Color := clWhite;
 Canvas.FillRect(Rect(0,0,Width,Height));
 Canvas.Pen.Color := color;
end;
end.
